PomModuleDescriptorParser
Date: 2014-12-13

org.apache.ivy.plugins.parser.m2

## Class PomModuleDescriptorParser

- java.lang.Object
- - org.apache.ivy.plugins.parser.m2.PomModuleDescriptorParser

- All Implemented Interfaces:
    ModuleDescriptorParser

      public final class PomModuleDescriptorParser
      extends java.lang.Object
      implements ModuleDescriptorParser

  A parser for Maven 2 POM.

  The configurations used in the generated module descriptor mimics the behavior defined by maven 2 scopes, as documented here:
  http://maven.apache.org/guides/introduction/introduction-to-dependency-mechanism.html The PomModuleDescriptorParser use a PomDomReader to read the pom, and the PomModuleDescriptorBuilder to write the ivy module descriptor using the info read by the PomDomReader.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(Resource res)`
    `static PomModuleDescriptorParser` | `getInstance()`
    `Artifact` | `getMetadataArtifact(ModuleRevisionId mrid, Resource res)` Returns the module metadata artifact corresponding to the given module revision id that this parser parses
    `java.lang.String` | `getType()` Return the 'type' of module artifacts this parser is parsing
    `ModuleDescriptor` | `parseDescriptor(ParserSettings ivySettings, java.net.URL descriptorURL, boolean validate)`
    `ModuleDescriptor` | `parseDescriptor(ParserSettings ivySettings, java.net.URL descriptorURL, Resource res, boolean validate)`
    `void` | `toIvyFile(java.io.InputStream is, Resource res, java.io.File destFile, ModuleDescriptor md)` Convert a module descriptor to an ivy file.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### getInstance

          public static PomModuleDescriptorParser getInstance()

    - #### toIvyFile

          public void toIvyFile(java.io.InputStream is,
                       Resource res,
                       java.io.File destFile,
                       ModuleDescriptor md)
                         throws java.text.ParseException,
                                java.io.IOException

      Description copied from interface: `ModuleDescriptorParser`
      Convert a module descriptor to an ivy file. This method MUST close the given input stream when job is finished
      Specified by:
        `toIvyFile` in interface `ModuleDescriptorParser`
      Parameters:
        `is` - input stream with opened on original module descriptor resource
      Throws:
        `java.text.ParseException`
        `java.io.IOException`

    - #### accept

          public boolean accept(Resource res)

      Specified by:
        `accept` in interface `ModuleDescriptorParser`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getMetadataArtifact

          public Artifact getMetadataArtifact(ModuleRevisionId mrid,
                                     Resource res)

      Description copied from interface: `ModuleDescriptorParser`
      Returns the module metadata artifact corresponding to the given module revision id that this parser parses
      Specified by:
        `getMetadataArtifact` in interface `ModuleDescriptorParser`
      Parameters:
        `mrid` - the module revision id for which the module artifact should be returned
        `res` - the resource for which the module artifact should be returned
      Returns:
        the module artifact corresponding to the given mrid and resource

    - #### getType

          public java.lang.String getType()

      Description copied from interface: `ModuleDescriptorParser`
      Return the 'type' of module artifacts this parser is parsing
      Specified by:
        `getType` in interface `ModuleDescriptorParser`
      Returns:
        the 'type' of module artifacts this parser is parsing

    - #### parseDescriptor

          public ModuleDescriptor parseDescriptor(ParserSettings ivySettings,
                                         java.net.URL descriptorURL,
                                         boolean validate)
                                           throws java.text.ParseException,
                                                  java.io.IOException

      Specified by:
        `parseDescriptor` in interface `ModuleDescriptorParser`
      Throws:
        `java.text.ParseException`
        `java.io.IOException`

    - #### parseDescriptor

          public ModuleDescriptor parseDescriptor(ParserSettings ivySettings,
                                         java.net.URL descriptorURL,
                                         Resource res,
                                         boolean validate)
                                           throws java.text.ParseException,
                                                  java.io.IOException

      Specified by:
        `parseDescriptor` in interface `ModuleDescriptorParser`
      Throws:
        `java.text.ParseException`
        `java.io.IOException`